﻿/// <summary>
/// Developer: CHOOI KAH WAI
/// Last Modified: 24/10/2009
/// </summary>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace ARSS.Visual
{
    /// <summary>
    /// Scene node for action marker
    /// </summary>
    public class ActSceneNode : SceneNode
    {
        #region Properties

        /// <summary>
        /// Action type for current scene node
        /// </summary>
        public int ActionCode { get; set; }

        #endregion

        #region Functions

        /// <summary>
        /// Load Action Scene Node
        /// </summary>
        /// <param name="_ele">XML element containing action scene node data</param>
        public void LoadNode(XElement ele)
        {
            MarkerID = int.Parse(ele.Attribute("arCode").Value);
            ModelPath = ele.Attribute("model").Value;
            ActionCode = int.Parse(ele.Attribute("actionCode").Value);
            Name = ele.Attribute("name").Value;
        }

        #endregion
    }
}
